import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.dates as mdates
import os
import datetime as dt
import openpyxl
import numpy as np
v_col = "Voltage [V]"
c_col = "Current [mA]"
p_col = "Power"
bat = "Battery"
time = "Time"

current_dir = os.getcwd()
directory = current_dir+'\\'+'Logs'+'\\'
save_dir = "graphs"+'\\'
node1 = "lora_node1"+'\\'
node2 = "lora_node2"+'\\'
node3 = "lora_node3"+'\\'
lte_node = "LTE-node1"+'\\'
start_date = dt.datetime(2020, 5, 14)



def make_graph(node, nr=''):
    i = 0
    bat_list = [] 
    date_list = []
    plt.figure(num=None, figsize=(15,10))
    plt.rcParams.update({'font.size': 30})
    while( (start_date+dt.timedelta(days=i)).date() <= dt.datetime(2020, 6,15).date() ):
        try:
            date_filename = (start_date+dt.timedelta(days=i)).date().strftime("%Y-%m-%d")
            date_plot = (start_date+dt.timedelta(days=i)).date().strftime("%d/%m")
            file_name = directory + node + date_filename + ".xlsx"
            table = pd.read_excel(file_name, usecols="B:F", convert_float = True)
            bat_temp = table['Battery'].tolist()
            bat_list.extend(bat_temp)

            temp_list = [date_plot for i in range(len(bat_temp))]
            date_list.extend(temp_list)

        except FileNotFoundError:
            pass
        i = i+1


    #fig, ax = plt.subplots(1, figsize=(15,10))
    ax = plt.gca()
    plt.cla()
    ax.plot(date_list, bat_list)
    ax.set_xticks(date_list[::2500]) 
    #plt.locator_params(axis='x', nbins=16)
    plt.gcf().autofmt_xdate()
    
    plt.ylabel('Battery level [%]')
    plt.savefig(directory+"battery\\"+node.replace('\\', '.jpg'))
    #plt.show()


if __name__ == "__main__":
    make_graph(node1, nr="1")
    make_graph(node2,nr="2")
    make_graph(node3, nr="3")
    make_graph(lte_node)


    print("ended")
